import{s as de,n as ge,o as ce}from"../chunks/scheduler.37c15a92.js";import{S as we,i as Le,g as l,s as i,r as P,A as ve,h as r,f as a,c as o,j as ue,u as A,x as s,k as ee,y as be,a as n,v as F,d as y,t as C,w as _}from"../chunks/index.7cb9c9b8.js";import{Y as He}from"../chunks/Youtube.8666c400.js";import{H as X}from"../chunks/Heading.d3928e2a.js";function Re(te){let p,I,x,O,h,S,m,ae=`Reinforcement learning from human feedback (RLHF) is a <strong>methodology for integrating human data labels into a RL-based optimization process</strong>.
It is motivated by the <strong>challenge of modeling human preferences</strong>.`,z,u,ne="For many questions, even if you could try and write down an equation for one ideal, humans differ on their preferences.",G,d,ie="Updating models <strong>based on measured data is an avenue to try and alleviate these inherently human ML problems</strong>.",q,g,D,c,oe="To start learning about RLHF:",E,w,le=`<li><p>Read this introduction: <a href="https://huggingface.co/blog/rlhf" rel="nofollow">Illustrating Reinforcement Learning from Human Feedback (RLHF)</a>.</p></li> <li><p>Watch the recorded live we did some weeks ago, where Nathan covered the basics of Reinforcement Learning from Human Feedback (RLHF) and how this technology is being used to enable state-of-the-art ML tools like ChatGPT.
Most of the talk is an overview of the interconnected ML models. It covers the basics of Natural Language Processing and RL and how RLHF is used on large language models. We then conclude with open questions in RLHF.</p></li>`,B,L,N,f,re='<li>Read other blogs on this topic, such as <a href="https://robotic.substack.com/p/rlhf-chatgpt-data-moats" rel="nofollow">Closed-API vs Open-source continues: RLHF, ChatGPT, data moats</a>. Let us know if there are more you like!</li>',j,v,U,b,se=`<em>Note, this is copied from the Illustrating RLHF blog post above</em>.
Here is a list of the most prevalent papers on RLHF to date. The field was recently popularized with the emergence of DeepRL (around 2017) and has grown into a broader study of the applications of LLMs from many large technology companies.
Here are some papers on RLHF that pre-date the LM focus:`,W,H,pe='<li><a href="https://www.cs.utexas.edu/~pstone/Papers/bib2html-links/ICDL08-knox.pdf" rel="nofollow">TAMER: Training an Agent Manually via Evaluative Reinforcement</a> (Knox and Stone 2008): Proposed a learned agent where humans provided scores on the actions taken iteratively to learn a reward model.</li> <li><a href="http://proceedings.mlr.press/v70/macglashan17a/macglashan17a.pdf" rel="nofollow">Interactive Learning from Policy-Dependent Human Feedback</a> (MacGlashan et al. 2017): Proposed an actor-critic algorithm, COACH, where human feedback (both positive and negative) is used to tune the advantage function.</li> <li><a href="https://proceedings.neurips.cc/paper/2017/hash/d5e2c0adad503c91f91df240d0cd4e49-Abstract.html" rel="nofollow">Deep Reinforcement Learning from Human Preferences</a> (Christiano et al. 2017): RLHF applied on preferences between Atari trajectories.</li> <li><a href="https://ojs.aaai.org/index.php/AAAI/article/view/11485" rel="nofollow">Deep TAMER: Interactive Agent Shaping in High-Dimensional State Spaces</a> (Warnell et al. 2018): Extends the TAMER framework where a deep neural network is used to model the reward prediction.</li>',Y,R,fe="And here is a snapshot of the growing set of papers that show RLHF’s performance for LMs:",J,T,he='<li><a href="https://arxiv.org/abs/1909.08593" rel="nofollow">Fine-Tuning Language Models from Human Preferences</a> (Zieglar et al. 2019): An early paper that studies the impact of reward learning on four specific tasks.</li> <li><a href="https://proceedings.neurips.cc/paper/2020/hash/1f89885d556929e98d3ef9b86448f951-Abstract.html" rel="nofollow">Learning to summarize with human feedback</a> (Stiennon et al., 2020): RLHF applied to the task of summarizing text. Also, <a href="https://arxiv.org/abs/2109.10862" rel="nofollow">Recursively Summarizing Books with Human Feedback</a> (OpenAI Alignment Team 2021), follow on work summarizing books.</li> <li><a href="https://arxiv.org/abs/2112.09332" rel="nofollow">WebGPT: Browser-assisted question-answering with human feedback</a> (OpenAI, 2021): Using RLHF to train an agent to navigate the web.</li> <li>InstructGPT: <a href="https://arxiv.org/abs/2203.02155" rel="nofollow">Training language models to follow instructions with human feedback</a> (OpenAI Alignment Team 2022): RLHF applied to a general language model [<a href="https://openai.com/blog/instruction-following/" rel="nofollow">Blog post</a> on InstructGPT].</li> <li>GopherCite: <a href="https://www.deepmind.com/publications/gophercite-teaching-language-models-to-support-answers-with-verified-quotes" rel="nofollow">Teaching language models to support answers with verified quotes</a> (Menick et al. 2022): Train a LM with RLHF to return answers with specific citations.</li> <li>Sparrow: <a href="https://arxiv.org/abs/2209.14375" rel="nofollow">Improving alignment of dialogue agents via targeted human judgements</a> (Glaese et al. 2022): Fine-tuning a dialogue agent with RLHF</li> <li><a href="https://openai.com/blog/chatgpt/" rel="nofollow">ChatGPT: Optimizing Language Models for Dialogue</a> (OpenAI 2022): Training a LM with RLHF for suitable use as an all-purpose chat bot.</li> <li><a href="https://arxiv.org/abs/2210.10760" rel="nofollow">Scaling Laws for Reward Model Overoptimization</a> (Gao et al. 2022): studies the scaling properties of the learned preference model in RLHF.</li> <li><a href="https://arxiv.org/abs/2204.05862" rel="nofollow">Training a Helpful and Harmless Assistant with Reinforcement Learning from Human Feedback</a> (Anthropic, 2022): A detailed documentation of training a LM assistant with RLHF.</li> <li><a href="https://arxiv.org/abs/2209.07858" rel="nofollow">Red Teaming Language Models to Reduce Harms: Methods, Scaling Behaviors, and Lessons Learned</a> (Ganguli et al. 2022): A detailed documentation of efforts to “discover, measure, and attempt to reduce [language models] potentially harmful outputs.”</li> <li><a href="https://arxiv.org/abs/2208.02294" rel="nofollow">Dynamic Planning in Open-Ended Dialogue using Reinforcement Learning</a> (Cohen at al. 2022): Using RL to enhance the conversational skill of an open-ended dialogue agent.</li> <li><a href="https://arxiv.org/abs/2210.01241" rel="nofollow">Is Reinforcement Learning (Not) for Natural Language Processing?: Benchmarks, Baselines, and Building Blocks for Natural Language Policy Optimization</a> (Ramamurthy and Ammanabrolu et al. 2022): Discusses the design space of open-source tools in RLHF and proposes a new algorithm NLPO (Natural Language Policy Optimization) as an alternative to PPO.</li>',K,$,V,M,me='This section was written by <a href="https://twitter.com/natolambert">Nathan Lambert</a>',Z,k,Q;return h=new X({props:{title:"RLHF",local:"rlhf",headingTag:"h1"}}),g=new X({props:{title:"Start Learning about RLHF",local:"start-learning-about-rlhf",headingTag:"h2"}}),L=new He({props:{id:"2MBJOuVq380"}}),v=new X({props:{title:"Additional readings",local:"additional-readings",headingTag:"h2"}}),$=new X({props:{title:"Author",local:"author",headingTag:"h2"}}),{c(){p=l("meta"),I=i(),x=l("p"),O=i(),P(h.$$.fragment),S=i(),m=l("p"),m.innerHTML=ae,z=i(),u=l("p"),u.textContent=ne,G=i(),d=l("p"),d.innerHTML=ie,q=i(),P(g.$$.fragment),D=i(),c=l("p"),c.textContent=oe,E=i(),w=l("ol"),w.innerHTML=le,B=i(),P(L.$$.fragment),N=i(),f=l("ol"),f.innerHTML=re,j=i(),P(v.$$.fragment),U=i(),b=l("p"),b.innerHTML=se,W=i(),H=l("ul"),H.innerHTML=pe,Y=i(),R=l("p"),R.textContent=fe,J=i(),T=l("ul"),T.innerHTML=he,K=i(),P($.$$.fragment),V=i(),M=l("p"),M.innerHTML=me,Z=i(),k=l("p"),this.h()},l(e){const t=ve("svelte-u9bgzb",document.head);p=r(t,"META",{name:!0,content:!0}),t.forEach(a),I=o(e),x=r(e,"P",{}),ue(x).forEach(a),O=o(e),A(h.$$.fragment,e),S=o(e),m=r(e,"P",{"data-svelte-h":!0}),s(m)!=="svelte-1d0jhk"&&(m.innerHTML=ae),z=o(e),u=r(e,"P",{"data-svelte-h":!0}),s(u)!=="svelte-agmibx"&&(u.textContent=ne),G=o(e),d=r(e,"P",{"data-svelte-h":!0}),s(d)!=="svelte-175gs7b"&&(d.innerHTML=ie),q=o(e),A(g.$$.fragment,e),D=o(e),c=r(e,"P",{"data-svelte-h":!0}),s(c)!=="svelte-11i2uem"&&(c.textContent=oe),E=o(e),w=r(e,"OL",{"data-svelte-h":!0}),s(w)!=="svelte-19bj7rn"&&(w.innerHTML=le),B=o(e),A(L.$$.fragment,e),N=o(e),f=r(e,"OL",{start:!0,"data-svelte-h":!0}),s(f)!=="svelte-1x9jdq0"&&(f.innerHTML=re),j=o(e),A(v.$$.fragment,e),U=o(e),b=r(e,"P",{"data-svelte-h":!0}),s(b)!=="svelte-131s5iq"&&(b.innerHTML=se),W=o(e),H=r(e,"UL",{"data-svelte-h":!0}),s(H)!=="svelte-ebh7ao"&&(H.innerHTML=pe),Y=o(e),R=r(e,"P",{"data-svelte-h":!0}),s(R)!=="svelte-nrrkz4"&&(R.textContent=fe),J=o(e),T=r(e,"UL",{"data-svelte-h":!0}),s(T)!=="svelte-67rlto"&&(T.innerHTML=he),K=o(e),A($.$$.fragment,e),V=o(e),M=r(e,"P",{"data-svelte-h":!0}),s(M)!=="svelte-17c4ke5"&&(M.innerHTML=me),Z=o(e),k=r(e,"P",{}),ue(k).forEach(a),this.h()},h(){ee(p,"name","hf:doc:metadata"),ee(p,"content",Te),ee(f,"start","3")},m(e,t){be(document.head,p),n(e,I,t),n(e,x,t),n(e,O,t),F(h,e,t),n(e,S,t),n(e,m,t),n(e,z,t),n(e,u,t),n(e,G,t),n(e,d,t),n(e,q,t),F(g,e,t),n(e,D,t),n(e,c,t),n(e,E,t),n(e,w,t),n(e,B,t),F(L,e,t),n(e,N,t),n(e,f,t),n(e,j,t),F(v,e,t),n(e,U,t),n(e,b,t),n(e,W,t),n(e,H,t),n(e,Y,t),n(e,R,t),n(e,J,t),n(e,T,t),n(e,K,t),F($,e,t),n(e,V,t),n(e,M,t),n(e,Z,t),n(e,k,t),Q=!0},p:ge,i(e){Q||(y(h.$$.fragment,e),y(g.$$.fragment,e),y(L.$$.fragment,e),y(v.$$.fragment,e),y($.$$.fragment,e),Q=!0)},o(e){C(h.$$.fragment,e),C(g.$$.fragment,e),C(L.$$.fragment,e),C(v.$$.fragment,e),C($.$$.fragment,e),Q=!1},d(e){e&&(a(I),a(x),a(O),a(S),a(m),a(z),a(u),a(G),a(d),a(q),a(D),a(c),a(E),a(w),a(B),a(N),a(f),a(j),a(U),a(b),a(W),a(H),a(Y),a(R),a(J),a(T),a(K),a(V),a(M),a(Z),a(k)),a(p),_(h,e),_(g,e),_(L,e),_(v,e),_($,e)}}}const Te='{"title":"RLHF","local":"rlhf","sections":[{"title":"Start Learning about RLHF","local":"start-learning-about-rlhf","sections":[],"depth":2},{"title":"Additional readings","local":"additional-readings","sections":[],"depth":2},{"title":"Author","local":"author","sections":[],"depth":2}],"depth":1}';function $e(te){return ce(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ae extends we{constructor(p){super(),Le(this,p,$e,Re,de,{})}}export{Ae as component};
